/*------------------------------------------------------------------------------
* garmin.h : garmin receiver dependent functions
*
*          Copyright (C) 2007 by T.TAKASU, All rights reserved.
*
* version : $Revision: 1.2 $ $Date: 2008/07/14 00:05:05 $
* history : 2008/05/21 1.0 new
*-----------------------------------------------------------------------------*/
#ifndef GARMIN_H
#define GARMIN_H
#include "rtklib.h"

#ifdef __cplusplus
extern "C" {
#endif

extern int decodegarm(const unsigned char *buff, int len, gtime_t ts, gtime_t te,
                      double tint, int opt, obs_t *obs);
extern void convgarm(FILE *fp, FILE *ofp, FILE *nfp, FILE *sfp, gtime_t ts,
                     gtime_t te, double tint, const rnxopt_t *rnxopt, int opt);
extern void readgarm(FILE *fp, gtime_t ts, gtime_t te, double tint, int opt,
                     obs_t *obss, int *nmax);

#ifdef __cplusplus
}
#endif
#endif /* GARMIN_H */
